
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>

#include "sound.h"

int g_hMemory;
volatile unsigned short *g_pusRegs;

//////////////////////////////////////////////////////////////////

#define GP2X_START	   (1<<8)
#define GP2X_SELECT    (1<<9)
#define GP2X_L         (1<<10)
#define GP2X_R         (1<<11)
#define GP2X_A         (1<<12)
#define GP2X_B         (1<<13)
#define GP2X_X         (1<<14)
#define GP2X_Y         (1<<15)
#define GP2X_VOL_UP    (1<<23)
#define GP2X_VOL_DOWN  (1<<22)
#define GP2X_PUSH      (1<<27)

unsigned long GetButtons()
{
  unsigned long value=(g_pusRegs[0x1198>>1] & 0x00FF);

  if(value==0xFD) value=0xFA;
  if(value==0xF7) value=0xEB;
  if(value==0xDF) value=0xAF;
  if(value==0x7F) value=0xBE;
 
  value =  ~((g_pusRegs[0x1184>>1] & 0xFF00) | value | (g_pusRegs[0x1186>>1] << 16));
	return value & 0x08C0FF00;
}

//////////////////////////////////////////////////////////////////

int main(int argc, char *argv[])
{
	int bMusicStopped = 0;

	g_hMemory = open("/dev/mem", O_RDWR);

  g_pusRegs = (unsigned short *) mmap(0, 0x10000, 
			PROT_READ|PROT_WRITE, MAP_SHARED, g_hMemory, 0xc0000000);

	InitSound();
	LoadSong("test.ogg");
	StartMusic();

	while(1)
	{
		if(GetButtons() & GP2X_START)
			break;
		else if(GetButtons() & GP2X_A)
		{
			while(GetButtons() & GP2X_A)
				;
			if(bMusicStopped)
				StartMusic();
			else
				StopMusic();
			bMusicStopped = !bMusicStopped;
		}
		else if(GetButtons() & GP2X_B)
		{
			while(GetButtons() & GP2X_B)
				;
			StopMusic();
			ResetMusic();
			StartMusic();
		}
		else if(GetButtons() & GP2X_X)
		{
			while(GetButtons() & GP2X_X)
				;
			StopMusic();
			LoadSong("test.ogg");
			StartMusic();
			bMusicStopped = 0;
		}

		usleep(10000);
	}

	StopMusic();
	CleanupSound();

	close(g_hMemory);

	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	return 0;
}
